// ssaver.c
//
//    Screen saver shell for S/MIME-RC240 brute force search
//    v1.0  Oct 1997 Jim Russell, SynData Technologies
//    Based on Microsoft sample SSAVER
//
//    This is linked to brute.cpp, which has the main search loop
//       
//****************************************************************************

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <scrnsave.h>
#include "resource.h"
#include "doframe.h"

HANDLE   hInst;        // our instance handle
UINT     wTimer = 0;     // Timer id

extern void    search_one_chunk(void);

extern short   iCurrCycle;
extern char    vcMsgBuf[];
extern short   bEnabled;

//****************************************************************************
BOOL WINAPI 
RegisterDialogClasses(
   HINSTANCE   hInst)
                                       // Entry point for registering 
                                       // window classes - required by 
                                       // configuration dialog box.
{
   return 1;
}
//****************************************************************************
BOOL CALLBACK 
ScreenSaverConfigureDialog(
   HWND     hWnd,
   UINT     Msg,
   WPARAM   wParam,
   LPARAM   lParam)
                                       // Process the screen saver config
                                       // messages for the config dialog
{
   switch(Msg)
   {
   case WM_COMMAND:
      switch(LOWORD(wParam))
      {
      case IDOK:                       // Exit the dialog
      case IDC_EXIT:
         EndDialog(hWnd, 42);
         break;
      }
      break;

   default:
      return FALSE;
      break;
   }
   return TRUE;
}
//****************************************************************************
LONG CALLBACK 
ScreenSaverProc(
   HWND     hWnd, 
   UINT     msg, 
   WPARAM   wParam, 
   LPARAM   lParam)
                                       // Processes screen saver messages
{                
   switch (msg)
   {
   case WM_TIMER:
                                       // The timer has triggered

                                       // Distinguish between the preview
                                       //    screen and the full-screen,
                                       //    just so that we don't start
                                       //    the search before they even
                                       //    decide to use the saver
      if (fChildPreview)
      {
         DrawFrame(hWnd, "BruteSav v1.0 (preview)");
      }
      else
      {
                                       // First, draw something on the
                                       //    screen -- any pending messages,
                                       //    and also a graphic
         DrawFrame(hWnd, vcMsgBuf);
                                       // Search a chunk of keyspace
                                       //    if the search is still on
         if (bEnabled)
            search_one_chunk();
      }

      return 0;
   
   case WM_ERASEBKGND:        
                                       // Seed the random number generator
      srand(GetTickCount());
                                       // fill the message buffer with
                                       //    a default message
      sprintf(vcMsgBuf,
         "BruteSav v1.0");
      
                                       // Tell windows to send us timer 
                                       // messages at 50ms intervals
      wTimer = SetTimer(hWnd, 0, 50, NULL);  
      break;       

    case WM_DESTROY:                   // message: window being destroyed
      if (wTimer)                      // Stop our timer if it was created
         KillTimer(hWnd, wTimer);
      break;              
    }  
    
    return DefScreenSaverProc(hWnd, msg, wParam, lParam); 
}
//****************************************************************************
//****************************************************************************
